// main.js for photo calendar diaRice 0.5 en/de 18:36 31.12.2008
// Copyright (c) 2007-2009 Michael Daum,  visit http://webdaum.de/

// this redirect forces the calendar to load the config data we need:
if(!location.search || location.search.indexOf("javascript")==-1) {
	
	// the forwarding URI will be removed from history:
	location.replace(location.search+(location.search?"&":"?")+"javascript=1");
	
} else {
	
	// set to global...
	var c_first_year;
	var c_first_month;
	var c_first_day;
	var c_direction;
	var c_image_path;
	var c_thumb_size;
	var c_never_ends;
	var c_sep;
	var c_suffices;
	var c_weekdays;
	var c_months;
	var c_short_months;
	var c_effects;
	var c_lang;
	var c_backtipp;
	var c_forwardtipp;
	var c_autoplay_speed;
	var c_month_n_day;
  
	// ... and grab config:
	window.document.onload = extract_data();
	
	// ... selected image presentation:
	for(var i=0;i<c_effects.length;i++) {
		document.writeln('<script type="text/javascript" src="'+c_effects[i]+'"></script>');
	}

  // todays date:
  var c_todays_date = new Date();
  var c_year  = c_todays_date.getFullYear();
  var c_month = c_todays_date.getMonth();
  var c_day   = c_todays_date.getDate();
  
  // usefull ones:
  var c_autoplay_var = false;
  var c_start = false;
  var c_end = false;
  var c_url = new Array();
  
  var c_month_length = new Array(31,28,31,30,31,30,31,31,30,31,30,31);
	
	// rebuild:
	calender_build_forward_backward();
	
  // _GET call for a specific day in the past:
  if(
	 location.search.indexOf("year") &&
	 location.search.indexOf("month") &&
	 location.search.indexOf("day") )
	{
	
    var _GET = new Array();
    
    var params = unescape(location.search.substring(1,location.search.length)).split("&");
    for(var i=0;i<params.length;i++) {
    	param = params[i].split("=");
    	_GET[param[0]] = param[1];
    }

	c_year = parseInt(_GET['year']);	
	c_month = parseInt(_GET['month'])-1;
	c_day = parseInt(_GET['day']);
	
	calendar_build_nav_month(c_year);
	
	if(_GET['lang']) {
		c_lang = _GET['lang'];
	}
	if(_GET['turn']) {
		c_direction = parseInt(_GET['turn']);
	}
  }
		 
  // set today's date:
  calendar_show_date(c_year,c_month,c_day);
} 
/* /// functions: /// */


function extract_data() {

  // extract data, convert to number:
  var form = document.forms[0];
  
  c_first_year  = Number(form.elements["first_year"].value); // starting year
  c_first_month = Number(form.elements["first_month"].value); // starting month, number  1 - 12 !!!
  c_first_day   = Number(form.elements["first_day"].value); // starting day, number 1 - 31 !!!
  c_direction   = Number(form.elements["my_direction"].value); // set the slideshow direction: 1 = forward, -1 = backward
  c_thumb_size  = Number(form.elements["thumb_size"].value);
  c_image_path  = form.elements["image_path"].value; // path to dir
  c_never_ends  = form.elements["calender_never_ends"].value;// enable display of dates in the future
  c_sep         = form.elements["sep"].value;// seperator seperating the months:
  c_suffices    = form.elements["my_suffices"].value.split(',');
  c_weekdays    = form.elements["my_daynames"].value.split(',');
  c_months      = form.elements["my_monthnames"].value.split(',');
  c_short_months= form.elements["my_short_monthnames"].value.split(',');
  c_effects     = form.elements["my_effects"].value.split(',');// image presentation js file(s) to include, can be multiple
  c_lang        = form.elements["lang"].value;
  c_backtipp    = form.elements["tooltipp_back"].value;
  c_forwardtipp = form.elements["tooltipp_forward"].value;
  c_autoplay_speed = form.elements["autoplay_speed"].value; // // set the slideshow speed in sec
	
}

// return the ordinal character to be used:
function todays_suffix() {
	  
  switch (c_lang) {
  
   	
   	case "fr":
      var suffix  = c_day==1? 1 : 0;
			return suffix;
			break;
			
   	case "en":
      var string  = c_day.toString();
      var ordinal = Number(string.substr(string.length-1,string.length));
      var suffix  = c_day<4 || (c_day>20 && ordinal < 4) ? ordinal: 0;
			return suffix;
			break;
			
  	default: // de, es
  		return 0;
   		break;
  
  }
}

// february needs some special treatment:
function calender_check_feb() {
	
	// is leap year?
	if(c_year==2008 || c_year == 2012 || c_year == 2016) {
	
		// add a day:
		c_month_length[1] = 29;
		
	}
}

// create calendar's years navigation:
function calendar_build_nav_year() {

	var nav_year = document.getElementById("navigation").getElementsByTagName("ul")[0];
	nav_year.innerHTML="";
	var m =25; // tabindex reserved  25 -55 !
	var i=c_never_ends=='0'?c_todays_date.getFullYear():c_year;
	for(i;i>=c_first_year;i--) {
	
		var j = (i==c_first_year)?c_first_month:0;
		var k = (i==c_first_year)?c_first_day:1;
			
		nav_year.innerHTML+='<li class="y-'+i+'"><a tabindex="'+(m++)+'" href="javascript:calendar_show_date('+i+','+j+','+k+')"><span>'+i+"</span></a></li>\n";	
	}
}

// create calendar's months navigation:
function calendar_build_nav_month(my_year) {

	var nav_month = document.getElementById("navigation").getElementsByTagName("ul")[1];
	nav_month.innerHTML="";
	
	var my_year_first_month = (my_year==c_first_year)?c_first_month:0;
	var my_year_last_month = (my_year==c_todays_date.getFullYear()&&c_never_ends=='0')?c_todays_date.getMonth():11;
	var m = 10; // tabindex 10-24
	
	for(var i=my_year_first_month;i<=my_year_last_month;i++) {
	
		var j = (i<10)?"0"+(i+1):(i+1);
		var k = (my_year==c_first_year && i==my_year_first_month)?c_first_day:1;
		var sep = i<my_year_last_month?c_sep:"";
			
		nav_month.innerHTML+='<li class="m-'+j+'"><a tabindex="'+(m++)+'" title="'+c_months[i]+'" href="javascript:calendar_show_date('+my_year+','+i+','+k+')"><span>'+c_short_months[i]+"</span></a>"+sep+"</li>\n";	
	}
}
// create calendar's days navigation:
function calendar_build_nav_day(my_year,my_month) {

	var tbody_nav_day = document.getElementsByTagName("tbody")[0];
	
	while (tbody_nav_day.getElementsByTagName("tr").length>0) {
		tbody_nav_day.deleteRow(0);
	}
	
	my_month_first_day =
		(
		my_year==c_first_year &&
		my_month == c_first_month
		)
		?c_first_day : 1;
			
	my_month_last_day =
		(
		my_year == c_todays_date.getFullYear() &&
		my_month == c_todays_date.getMonth() &&
		c_never_ends=='0'
		)
		?c_todays_date.getDate() : c_month_length[my_month];
		
	timestamp = new Date(my_year,my_month,my_month_first_day,0,0,0);
	C_WDAY = timestamp.getDay();
		
	k=1;
	
	for(var i=my_month_first_day;i<=my_month_last_day;i++) {
	
	
		active = i==c_day?" class=\"active\"":"";
		
		if(k==1 && C_WDAY>0) {
			tr = tbody_nav_day.insertRow(tbody_nav_day.rows.length);
			for(j=0;j<C_WDAY;j++) {
				td = tr.insertCell(j);
			}	
		} else if(k==1) {
			tr = tbody_nav_day.insertRow(tbody_nav_day.rows.length);
		}
		
		td = tr.insertCell(tr.cells.length)
		td.innerHTML='<a tabindex="'+(i+55)+'" onmouseover="do_preview(this)" href="javascript:calendar_show_date('+
		my_year+','+my_month+','+i+')"'+" "+active+"><span>"+i+"</span></a>";
		
		//k++;
		
		if((++k+C_WDAY)%7==1 && i<my_month_last_day) {
			tr = tbody_nav_day.insertRow(tbody_nav_day.rows.length);	
		}
		
	}		
	
} // end function calendar_build_nav_day
	
// rewrite calendar's forward-backward navigation:
function calender_build_forward_backward() {

	// tabindex 1,2
	document.getElementById("back").innerHTML='<a tabindex="1" accesskey="v" title="'+c_backtipp+'" href="javascript:calender_turn_page(-1)"><span>&laquo;</span></a>';
	document.getElementById("forward").innerHTML='<a tabindex="2" accesskey="n" title="'+c_forwardtipp+'" href="javascript:calender_turn_page(+1)"><span>&raquo;</span></a>';
	
}
	
// rewrite calendar's wikipedia links:
function calender_build_wpd_links() {
	
	if(my_wikipedia=document.getElementById("wikipedia")) {
	
		var wpd_url = "http://"+c_lang+".wikipedia.org/wiki/";
		
  	c_url['wpd_year'] = wpd_url+c_year;
  	c_url['wpd_month']= wpd_url+encodeURIComponent(c_months[c_month]);
  	c_url['wpd_day']  = wpd_url+encodeURIComponent(c_month_n_day.replace(" ","_"));
	
	my_wikipedia.innerHTML =
'<li><a tabindex="200" href="'+c_url['wpd_day']+'"><span>'+c_month_n_day+'</span></a></li>'+
'<li><a tabindex="201" href="'+c_url['wpd_month']+'"><span>'+c_months[c_month]+'</span></a></li>'+
'<li><a tabindex="202" href="'+c_url['wpd_year']+'"><span>'+c_year+'</span></a></li>';
	}
}

// display a specific date, this is the main function:
function calendar_show_date(my_year,my_month,my_day) {
  
  // check if ajax request is running already:
  if(window.fetch_comments) {
  	clearTimeout(fetch_comments);
  }
  // date auto preselection:
  c_year  = my_year  || c_todays_date.getFullYear();
  c_month = my_month || c_todays_date.getMonth();
  c_day   = my_day   || c_todays_date.getDate();
  
  if(my_month === 0) c_month = 0; 
  
  // detect end:
	if(c_year  == c_todays_date.getFullYear() &&
   	 c_month == c_todays_date.getMonth() &&
     c_day   == c_todays_date.getDate() &&
	 c_never_ends == '0' ) {
   
		c_end = true;
		
	} else {
		c_end = false;
	}
	
	// detect start:
	if(c_year  <= c_first_year &&
   c_month == c_first_month &&
   c_day   == c_first_day ) {

		c_start = true;

	} else {
		c_start = false;
	}
	
  // initialize today's date:
  c_show_date = new Date(c_year,c_month,c_day);

  
  // for the wikipedia links:  
  if(c_lang=="es") { 
		c_month_n_day = c_day+" "+c_suffices[0]+" "+c_months[c_month]; 
  } else if(c_lang=="de"||c_lang=="da") {  
		c_month_n_day = c_day+c_suffices[0]+" "+c_months[c_month];  
  } else if(c_lang=="en") {
  	c_month_n_day = c_months[c_month]+" "+c_day; 	
  } else {
  	// fr it nl
  	c_month_n_day = c_day+" "+c_months[c_month].toLowerCase(); 	  	
  }
  // rebuild year's navigation:
  calendar_build_nav_year();  
  
  // rebuild month's navigation:
  calendar_build_nav_month(c_year);
  
  // rebuild day's navigation:
  calendar_build_nav_day(c_year,c_month);
    
	// rebuild wikipedia links:
	calender_build_wpd_links();
  
  // don't show navigation-link pointing to dates newer than today's date:
  if(c_end) {  
  	document.getElementById("forward").style.display="none";
  	if(c_direction == 1) {
			calendar_autoplay('stop');
		}
  } else {
  	document.getElementById("forward").style.display="block"; 
  }
	
  // don't show navigation link pointing to a date previous the date calendar started:
  if(c_start) {  
  	document.getElementById("back").style.display="none";
  	if(c_direction == -1) {
			calendar_autoplay('stop');
		}
  } else {
  	document.getElementById("back").style.display="block"; 
  }
    
  // Debug:
  //alert (c_show_date);
  //alert(i+"-"+j+"-"+k);
  
  // update the display:
  document.getElementById("calendar").className="y-"+c_year+" "+c_lang;
  document.getElementById("year").innerHTML=c_year;
  document.getElementById("month").innerHTML=c_months[c_show_date.getMonth()];
  document.getElementById("weekday").innerHTML=c_weekdays[c_show_date.getDay()];
  document.getElementById("the-day").innerHTML=c_day;
  document.getElementById("the-suffix").innerHTML=c_suffices[todays_suffix()];;
  
  try {
		calendar_set_image();
	} catch(e) {		
  	var c_0_day = c_day<10?"0"+c_day:c_day;
  	var i = c_month+1;
  	var c_0_month = i<10?"0"+i:i;
		document.getElementById("image").style.backgroundImage =
		"url("+c_image_path+c_year+"/"+c_0_month+"/_"+c_0_day+".jpg)";
		//alert("error");
	}
	  
  // load image description:
  if(window.document.getElementById("image-description")) {
		calendar_ajax_load("image_description","image-description");
	}
	//check & fetch comments:
	if(window.document.getElementById("comment")) {
		fetch_comments = window.setTimeout('calendar_ajax_load("get_comments","archive")',2000);
		document.forms[1].setAttribute("action",calendar_url()+"&amp;go=comment");
	}
}

// forward - backward single item navigation - modify the slideshow direction:
function calender_turn_page(direction) {
	
  calender_check_feb();
	
  //check:
  switch (direction) {
  
  	case -1:
  		if(c_day+direction<=0) {
  			if( c_month>0) {
  				c_month-= 1;
  				c_day = c_month_length[c_month];
  			} else {
  				c_month = 11;
  				c_year-= 1;
  				c_day = 31;
  			}
  		} else {
				c_day+= direction;
			}
			push('back');
			release('forward');
  		break;
  		
  	case 1: 
  	
  		if(c_day+direction>c_month_length[c_month]) {
  			c_day = 1;
  			if( c_month<11) {
  				c_month+= 1;
  			} else {
  				c_month = 0;
  				c_year+= 1;
  			}
  		} else {
				c_day+= direction;
			}
			push('forward');
			release('back');
  		break;
  
  }
 
  calendar_show_date(c_year,c_month,c_day);
  
  // modify slideshow direction:
  if(direction!=c_direction) {
  	//turn:
  	c_direction*= -1;
  	// restart:
  	if(c_autoplay_var) { 
  		calendar_autoplay('stop');
  		calendar_autoplay(c_direction);
  	}
  }
  
}

// slideshow:
function calendar_autoplay(direction) {

	direction = direction || c_direction;
	
	switch(direction) {
	
		case 1:
			if(c_end) {
				calendar_show_date(c_first_year,c_first_month,c_first_day);
			}
			push('play');
			release('stop');
			break;
			
		case -1:
			if(c_start) {
				calendar_show_date();
			}
			push('play');
			release('stop');
			break;			
			
		case 'stop':
			push('stop');
			release('play');
			if(c_autoplay_var) {
				window.clearInterval(c_autoplay_var);
				c_autoplay_var = false;
				return;
			}
			break;
	}
	
	if(!c_autoplay_var && direction) {
		c_autoplay_var = window.setInterval('calender_turn_page('+direction+')',c_autoplay_speed*1000);
	}
}


function push(e) {
	var ele = e;
	document.getElementById(ele).getElementsByTagName("a")[0].className = "active";
}
function release(e) {
	var ele = e;
	document.getElementById(ele).getElementsByTagName("a")[0].className = "";
}

function calendar_preload_month(c_0_month) {
	

	calender_check_feb();
	var preload = new Array(c_month_length[c_month]);
	//var imagenames = "";
	var max = c_0_month-1==c_todays_date.getMonth()?c_todays_date.getDate():c_month_length[c_month];
	
	for(var i=1;i<=max;i++) {
	
  	var c_0_day = i<10?"0"+i:i;
		preload[i] = new Image();
		preload[i].src = c_image_path+c_year+"/"+c_0_month+"/_"+c_0_day+".jpg";
		//imagenames+=preload[i].src + "\n";
	}
	//alert(imagenames);
}

function calendar_url() {

	var url = "?year="+c_year+"&month="+(c_month+1)+"&day="+c_day+"&lang="+c_lang;
  var i;
  
  if(!c_end && c_direction!=-1) {
		i = "+1";   
  }
  if(!c_start && c_direction!=+1) {  
  	i = "-1";
  }
  
	url+="&direction="+i+"&javascript=1";
	
	return url;
	
}
function calendar_ajax_load(resource,send_to) {

	//send_to = send_to || "image-description";  
	var url=calendar_url()+"&ajax="+resource; 

	try { 

		// run ajax request in IE:
		if(document.all&& !window.opera) {
			xmlhttp.open("GET",url,true);
		}
		xmlhttp.onreadystatechange=function() {
			if (xmlhttp.readyState == 4 && xmlhttp.responseText) { 
				if(xmlhttp.status == 200) {
					document.getElementById(send_to).innerHTML = xmlhttp.responseText;
				}
			} 
		}
		// run ajax request in firefox/opera/safari:
		if(!document.all || window.opera) {
			xmlhttp.open("GET",url,true);
		}
		xmlhttp.send(null);		

	} catch (e) { 

		var index = send_to=="image-description"?0:1;

		if(!window.frames[index]) {
			iframe= '<iframe frameborder="0" src="about:blank"></iframe>';  		
			document.getElementById(send_to).innerHTML = iframe;	
		}
		window.frames[index].location.href=url+"&iframe=1";
	}
	return false;	
}

function do_preview(ele) {
	
	if(!ele.getElementsByTagName("img").length) {
		var day = Number(ele.firstChild.innerHTML);
		var c_0_day = day<10?"0"+day:day;
		var c_0_month = c_month+1<10?"0"+(c_month+1):(c_month+1);
		var thumb = document.createElement("IMG");
		var src = c_image_path+c_year+"/"+c_0_month+"/_"+c_0_day+".jpg";
		
		// retrieve image info:
		var test = new Image();
		test.src = src;
		var h = test.height;
		var w = test.width;
		var l = 266;
		var s = 0.25;
		if(h>w) {
			l=h;
			thumb.className="upright";
		} else {
			l=w;
		}
		s = c_thumb_size/l;
		
		thumb.src = src;
		thumb.setAttribute("width",Math.round(s*w));
		thumb.setAttribute("height",Math.round(s*h));
		thumb.setAttribute("alt","preview!");
		ele.appendChild(thumb);
	}
	return false;
}
