<?php
// comment.php for diaRice - photo calendar 0.5 en/de 08.22.2007 21:32
// Copyright (c) 2007 Michael Daum,  visit http://webdaum.de/

  // Includes
  include (_PATH."/lang/translate.php");
  include_once (_PATH."/include/function.php");
  include_once (_PATH."/classes/profile.inc.php");
  include (_PATH."/data/profile_data.php");
  
  // set from 0 to 1 to protect against spamming
  $antispam = 1;
  
  // textmessages containing more links than that are treated as spam:
  $max_hyperlinks = 3;

  // set from 0 to 1 to check email-address:
  $check_email = 1;

  // set from 0 to 1 to protect against reload
  $on = 1;
  
  // time of protection against reload in minuits
  $min = 0.5;
  
  // list of allowed tags, remove # to make active:
  $tags = array(
    "p"=>P,
    #"b"=>B,
    "strong"=>STRONG,
    #"h3"=>H3,
    "em"=>EM,
    #"u"=>U,
    #"pre"=>PRE,
    ##"div"=>DIV,
    #"code"=>CODE,
    #"small"=>SMALL,
    "big"=>BIG,
    "cite"=>CITE,
    #"blockquote"=>BLOCKQUOTE,
    "br"=>BR,
    #"hr"=>HR,
    "a"=>A,
    #"ul"=>UL,
    #"li"=>LI,
    #"table"=>TABLE,
    #"tr"=>TR,
    #"td"=>TD,
    #"url"=>URL,
    #"img"=>IMG,
    #"ent"=>ENT,
    #"unent"=>UNENT
    #"ins"=>INS,
    #"del"=>DEL,
    #"!--"=>"HTML ".MENU_COMMENT
  );
  
  // handle comment request for privileged article author:
  if(isset($_SESSION["auth"])&& isset($profile[$_SESSION["auth"]])) {
    $antispam = 0;
    $_POST['submit'] = 1;
    $_POST['user_name'] = $profile[$_SESSION["auth"]]->fullname();
    $_POST['email'] = $profile[$_SESSION["auth"]]->email;
    if(!isset($_POST['text'])) {
      $_POST['text'] = "";  
      $_POST['website'] = $profile[$_SESSION["auth"]]->website;  
    }  
    $_POST['nr_1'] = 2;    
    $_POST['nr_2'] = 2;  
    $_POST['RE_code'] = 4;    
  }
 

  if(isset($_POST['submit'])) {
  
    include_once "classes/formcheck.inc.php";
    $form = new formcheck (
      $this->c_lang,
      $antispam,
      $max_hyperlinks,
      $check_email,
      $tags
    );
    
    if($form->ok() ) {
      
      // timestamp:
      $comment_time = time();
	  
      // create obj:
      $comment[$comment_time] = new comment (
        $this->c_timestamp,
        $form->field['user_name'],
        $form->field['email'],
        $form->field['text'],
        $comment_time,
        $form->field['website'],
        false,
        $form->field['auth_name']
      );
	  
      // select db:
      $file = $comment[$comment_time]->database;
      
      // set comment to online at once for privileged article author:
      if(isset($_SESSION["auth"])) {
        $comment[$comment_time]->accept();
      }
      
      // is set to true if IP-reload check == 0 and data is written
      $ok=false;
      
      if (file_exists($file) && ($on==0 || ($on==1 && $form->check_IP($min)==0))) {
        // save to existing database:
        require_once $file;
          
        // save:
        if($comment[$comment_time]->to_database()) {
          $ok = true;
        }
      } else if (!file_exists($file) && ($on==0 || ($on==1 && $form->check_IP($min)==0))) {
      	// create new dir:
      	if(!is_dir(dirname($file))) {
      		mkdir(dirname($file));
      	}
        // create new file and save.
        $fp=fopen($file,"w");
        fputs($fp,"<?php\n".$comment[$comment_time]->processComment()."?".">");
        fclose($fp);
        $ok = true;
      } 
      /* inform autor:*/
      if(isset($profile[$this->c_author[$this->c_day]])&& $profile[$this->c_author[$this->c_day]]->fullname!=="") {
        $emailadress = $profile[$this->c_author[$this->c_day]]->email;
      } else $emailadress = $this->c_my_email;
      if($ok && !isset($_SESSION["auth"])) {
        if(empty($form->field['email'])) {
          $form->field['email']="nobody@unknown.net";
        }
		$url_to_edit = $this->c_host.$this->c_phpself.
		"?go=index&mode=comment&id=$this->c_timestamp&do=$comment_time";
		
        mail(
          $emailadress,
          $form->field['user_name'].
          " @ ".
          $this->print_day(),
          $form->field['text']."\n\n".
		  "quick link: $url_to_edit\n\n".
          $form->field['user_name']." | ".
          $form->field['website'],
          "From: ".
          $form->field['email']
        );
      // thanks!
        header("Location:?go=thanks");
      }  else if(isset($_SESSION["auth"])) {
      header("Location:$url_to_edit");
      }    
    } 
  }
  if(isset($_GET['submit'])) {
    echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>'.$_LANG['add_a_note'].'</title>
<meta http-equiv="Content-Type" content=
"text/html; charset="'.$this->c_charset.'" />
<link rel="stylesheet" type="text/css" href="'.$this->c_style.'" />
<script type="text/javascript" src="js/editor.js" charset="iso-8859-1"></script>
</head>
<body>
<div id="comment">';
  } else {
    echo "<h3>".MENU_COMMENTS.'<a name="comments"> </a></h3>'."\n";
    echo '<ul id="archive">'."\n";
    echo $this->get_comments();
    echo "</ul>\n";
  }
?>
<h3><?php echo $_LANG['add_a_note']?></h3>
<script type="text/javascript" src="js/editor.js"></script>
<form method="post" id="form" action=
"?go=comment<?php echo htmlentities("&year=$this->c_year&month=$this->c_month&day=$this->c_day&turn=$this->c_direction&lang=$this->c_lang");?>">
<fieldset><legend>:: <?php echo $_LANG['legend_visitor_data']?> ::</legend> 
<div>
<input type="hidden" name="auth_name" value="<?php if(isset($_SESSION["auth"])) echo $_SESSION["auth"];?>" />
<dfn><?php echo $_LANG['dfn_visitor_name']?></dfn><input type="text" name="user_name" value="<?php echo @$form->field['user_name']?>" alt="Name" /><br />
<dfn><?php echo $_LANG['dfn_email']?></dfn><input type="text" name="email" value="<?php echo @$form->field['email']?>" alt="Email" /><br />
<dfn><?php echo $_LANG['dfn_website']?> <b>http://</b></dfn><input type="text" name="website" value="<?php echo @$form->field['website']?>" alt="Website" /><br />
</div>
<?php
if(isset($form) && @!$form->ok() ) {
  echo '<div id="msg"><p>'.$form->msg()."</p>
</div>
";
}
if($antispam) {
  if(!isset($form)) {
    $nr_1 = rand(1,30);
    $nr_2 = rand(1,30);
  } else {
    $nr_1 = $_POST["nr_1"];
    $nr_2 = $_POST["nr_2"];  
  }
?>
<p><?php echo $_LANG['tip_comment']?></p>
</fieldset>
<fieldset><legend>:: <?php echo $_LANG['legend_antispam']?> ::</legend> 
<div>
<p><?php echo $_LANG['msg_insert_code']."<strong> $nr_1 + $nr_2</strong>"; ?>?</p>
<dfn><?php echo $_LANG['dfn_antispam']?></dfn><input type="text" name="RE_code" value="<?php echo @$form->field['RE_code']?>" alt="RE_code" /><br />
</div>
<input type="hidden" name="nr_1" value="<?php echo $nr_1?>" />
<input type="hidden" name="nr_2" value="<?php echo $nr_2?>" />
<p>(<?php echo $_LANG['msg_antispam']?>.)</p>
</fieldset>
<fieldset><legend>:: <?php echo $_LANG['dfn_text']?> ::</legend>
<div id="entry">
<div id="editor">
<?php
  foreach($tags as $k => $v) {
    echo "<input type=\"button\" class=\"$k\" value=\"$k\" title=\"$v\" onclick=\"edit(this)\" />\n";
  }
?>
</div>
<textarea rows="12" cols="40" name="text" title="Textfeld"><?php echo stripcslashes(@$form->field['text'])?>
</textarea>
<input type="submit" name="submit" class=
"submit" value="<?php echo $_LANG['form_submit']?>" />
</div>
<p><?php echo $_LANG['dfn_allowed_tags'].":<br />";?>
<?
$tags = array_flip ($tags);
$tags = array_values ($tags);

foreach($tags as $k => $v) {
echo "&lt;$v&gt;";
echo $k<count($tags)-1?", ":"";
}
?>
</p>
<p><?php echo $_LANG['msg_forbidden_tags']?>.</p>

<?php 
}

echo "</fieldset>\n</form>\n";

if(isset($_GET['submit'])) {
  echo '</div></body></html>';
}
?>