<?php 
// function.inc.php for diaRice - photo calendar 0.5 en/de 07.09.2007 13:46
// Copyright (c) 2007 Michael Daum,  visit http://webdaum.de/

function daten_reiniger($inhalt) {
	
	if( is_array($inhalt)) {
		foreach($inhalt as $key => $item) {
			$inhalt[$key] = milder_reiniger($item);
		}
	} else if (!empty($inhalt)) {
	
		$inhalt = strip_tags($inhalt,"<p>,<b>,<i>,<a>,<u>,<cite>,<code>,<pre>,<span>,<small>,<big>,<em>,<strong>,<img>,<br>,<hr>,<!>");
		$inhalt = str_replace("'", "&#8217;", $inhalt);
		$inhalt = str_replace("|", "&#921;", $inhalt);
		$inhalt = trim($inhalt);
		$inhalt = nl2br($inhalt);
		$inhalt = str_replace("\n","",$inhalt);
		$inhalt = str_replace("\r","",$inhalt);
		$inhalt = stripslashes($inhalt);
		$inhalt = stripcslashes($inhalt);
		$inhalt = str_replace("<br>", "<br />", $inhalt);
		$inhalt = str_replace("<hr>", "<hr />", $inhalt);
	}
	return $inhalt;
}
function milder_reiniger($inhalt, $strip_slashes=false) {

	if( is_array($inhalt)) {
		foreach($inhalt as $key => $item) {
			$inhalt[$key] = milder_reiniger($item, $strip_slashes);
		}
	} else if (!empty($inhalt)) {
		$inhalt = str_replace("", "&#8217;", $inhalt);
		$inhalt = str_replace("`", "&#8217;", $inhalt);
		$inhalt = str_replace("&nbsp;", "&#160;", $inhalt);
		$inhalt = str_replace("'", "&#8217;", $inhalt);
		$inhalt = trim($inhalt);
		$inhalt = str_replace("\f","",$inhalt);
		$inhalt = str_replace("\r","",$inhalt);
		#$inhalt = str_replace("\n","",$inhalt);
		
		if($strip_slashes) {
			$inhalt = stripslashes($inhalt);
			#$inhalt = stripcslashes($inhalt);
		}
		$inhalt = str_replace("<br>", "<br />", $inhalt);
		$inhalt = str_replace("<hr>", "<hr />", $inhalt);
	}
	return $inhalt;
}		
	
function getmicrotime() {
	list($usec, $sec) = explode(" ",microtime()); 
  return ((float)$usec + (float)$sec); 
}

function to_string($array) {
	$out = "";
	static $i = 0;
	foreach ($array as $param => $val) {
		$i>0?$out.= "&":"";
		$out.= "$param=$val";
		$i++;  			
	}
	return $out;
}
  	
if(!function_exists('file_put_contents')) {
  function file_put_contents($dateiname, $datei_inhalt, $datei_anhang = false) {
   $fp = fopen($dateiname, (!$datei_anhang ? 'w+' : 'a+'));
   if(!$fp) {
     trigger_error('file_put_contents kann nicht in die Datei '.$dateiname.' schreiben.', E_USER_ERROR);
     return false;
   }
   fputs($fp, $datei_inhalt);
   fclose($fp);
   return true;
  }
}
function is_bot($ua) {
	
  $file = "files/botlist.txt";
  if(!is_file($file)) {
  	$file="../$file";
  }
  
  $bots = file($file);
  foreach ($bots as $needle) {
  	$needle = trim($needle);
  	if(strpos(strtolower($ua),strtolower($needle)) === false || $needle=="") {
  		continue;
  	} else return true;
  }
  return false;
}
?>